Attribute VB_Name = "APIShellExecute"
Option Explicit

Public Type SHELLEXECUTEINFO
    cbSize As Long
    dwHotKey As Long
    fMask As Long
    hIcon As Long
    hInstApp As Long
    hkeyClass As Long
    hProcess As Long
    hwnd As Long
    lpClass As String
    lpDirectory As String
    lpFile As String
    lpIDList As Long
    lpParameters As String
    lpVerb As String
    nShow As Long
End Type

Public Const SEE_MASK_NOCLOSEPROCESS = &H40
Public Const SW_SHOWNORMAL = 1
Public Declare Function ShellExecuteEx Lib "shell32.dll" Alias "ShellExecuteExA" _
                                          (lpExecInfo As SHELLEXECUTEINFO) As Long
Public Const SE_ERR_FNF = 2
Public Const SE_ERR_NOASSOC = 31

Public Function LaunchAppSynchronous(pEXE As String, pCmdLine As String, _
                pCurPath As String, pHwnd As Long, pForm As Form) As Boolean

    'Launches an executable by starting it's process
    'then waits for the execution to complete.
    'INPUT: The executables full path and name, any command prompts, and the current directory
    'RETURN: 1 upon termination if successful, 0 if not.

Dim sei As SHELLEXECUTEINFO  ' structure used by the function
    Dim retval As Long  ' return value
    
    With sei
        ' Size of the structure
        .cbSize = Len(sei)
        ' Use the optional hProcess element of the structure.
        .fMask = SEE_MASK_NOCLOSEPROCESS
        ' Handle to the window calling this function.
        .hwnd = pHwnd
        ' The action to perform: open the file.
        .lpVerb = "open"
        ' The file to open.
        .lpFile = pEXE
        ' Any parameters required?
        .lpParameters = pCmdLine
        ' The emulators directory
        .lpDirectory = pCurPath
        ' Simply display the window.
        .nShow = SW_SHOWNORMAL
        ' The other elements of the structure are either not used
        ' or will be set when the function returns.
    End With
    
    ' Debug.Print pCmdLine
    
    ' Open the file using its associated program.
    retval = ShellExecuteEx(sei)
    'starttime = Time
    LaunchAppSynchronous = retval
    
    ' Debug.Print retval
    If retval = 0 Then MsgBox "An unexpected error occured."
    
End Function


